unit AISBDE;

interface

uses
  Classes, DBTables, Forms, MSScriptControl_TLB,

  AIScriptControl, AIScriptHandler, BDESQL;

type
  TAIBDE = class(TComponent)
  private
    FDB         :TDatabase;
  public
    constructor Create(AOwner:TComponent);override;
    destructor  Destroy();override;
  published
    property    DB:TDatabase              read  FDB;
  end;

  TAIBDEHandler = class(TAIScriptHandler)
  published
  end;

  TAIBDESQLHandler = class(TAIScriptHandler)
  published
    class procedure   M_Prepare (Ex:TAIContext);
    class procedure   M_Close   (Ex:TAIContext);
    class procedure   M_Open    (Ex:TAIContext);
    class procedure   M_Exec    (Ex:TAIContext);

    class procedure   M_Edit    (Ex:TAIContext);
    class procedure   M_Post    (Ex:TAIContext);

    class procedure   M_New     (Ex:TAIContext);
    class procedure   M_Add     (Ex:TAIContext);

    class procedure   M_First   (Ex:TAIContext);
    class procedure   M_Next    (Ex:TAIContext);
    class procedure   M_Last    (Ex:TAIContext);
    class procedure   M_Prior   (Ex:TAIContext);

    class procedure   M_Refresh (Ex:TAIContext);

    class procedure   I_GetG    (Ex:TAIContext);

    class procedure   I_GetI    (Ex:TAIContext);
    class procedure   I_GetS    (Ex:TAIContext);
    class procedure   I_GetBLOB (Ex:TAIContext);
    class procedure   I_GetF    (Ex:TAIContext);
    class procedure   I_GetC    (Ex:TAIContext);
    class procedure   I_GetM    (Ex:TAIContext);
    class procedure   I_GetD    (Ex:TAIContext);
    class procedure   I_GetB    (Ex:TAIContext);
    class procedure   I_GetT    (Ex:TAIContext);

    class procedure   I_SetI    (Ex:TAIContext);
    class procedure   I_SetS    (Ex:TAIContext);
    class procedure   I_SetBLOB (Ex:TAIContext);
    class procedure   I_SetF    (Ex:TAIContext);
    class procedure   I_SetC    (Ex:TAIContext);
    class procedure   I_SetM    (Ex:TAIContext);
    class procedure   I_SetD    (Ex:TAIContext);
    class procedure   I_SetB    (Ex:TAIContext);
    class procedure   I_SetT    (Ex:TAIContext);
  end;


var
  AIBDE:TAIBDE;

implementation

{ TAIBDE }

constructor TAIBDE.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);

  FDB:=TDatabase.Create(Self);
end;

destructor TAIBDE.Destroy;
begin

  inherited;
end;

{ TAIAppHandler }

{ TAIBDESQLHandler }

class procedure TAIBDESQLHandler.I_GetB(Ex: TAIContext);
begin
  Ex.OutValue:=TBDESQL(Ex.Obj).B[Ex.IndexValue];
end;

class procedure TAIBDESQLHandler.I_GetBLOB(Ex: TAIContext);
begin
  Ex.OutValue:=TBDESQL(Ex.Obj).BLOB[Ex.IndexValue];
end;

class procedure TAIBDESQLHandler.I_GetC(Ex: TAIContext);
begin
  Ex.OutValue:=TBDESQL(Ex.Obj).C[Ex.IndexValue];
end;

class procedure TAIBDESQLHandler.I_GetD(Ex: TAIContext);
begin
  Ex.OutValue:=TBDESQL(Ex.Obj).D[Ex.IndexValue];
end;

class procedure TAIBDESQLHandler.I_GetF(Ex: TAIContext);
begin
  Ex.OutValue:=TBDESQL(Ex.Obj).F[Ex.IndexValue];
end;

class procedure TAIBDESQLHandler.I_GetG(Ex: TAIContext);
begin
  Ex.OutValue:=Ex.GetObjContext(TBDESQL(Ex.Obj).G[Ex.IndexValue]);
end;

class procedure TAIBDESQLHandler.I_GetI(Ex: TAIContext);
begin
  Ex.OutValue:=TBDESQL(Ex.Obj).I[Ex.IndexValue];
end;

class procedure TAIBDESQLHandler.I_GetM(Ex: TAIContext);
begin
  Ex.OutValue:=TBDESQL(Ex.Obj).M[Ex.IndexValue];
end;

class procedure TAIBDESQLHandler.I_GetS(Ex: TAIContext);
begin
  Ex.OutValue:=TBDESQL(Ex.Obj).S[Ex.IndexValue];
end;

class procedure TAIBDESQLHandler.I_GetT(Ex: TAIContext);
begin
  Ex.OutValue:=TBDESQL(Ex.Obj).T[Ex.IndexValue];
end;

class procedure TAIBDESQLHandler.I_SetB(Ex: TAIContext);
begin
  TBDESQL(Ex.Obj).B[Ex.IndexValue]:=Ex.Args[0];
end;

class procedure TAIBDESQLHandler.I_SetBLOB(Ex: TAIContext);
begin
  TBDESQL(Ex.Obj).BLOB[Ex.IndexValue]:=Ex.Args[0];
end;

class procedure TAIBDESQLHandler.I_SetC(Ex: TAIContext);
begin
  TBDESQL(Ex.Obj).C[Ex.IndexValue]:=Ex.Args[0];
end;

class procedure TAIBDESQLHandler.I_SetD(Ex: TAIContext);
begin
  TBDESQL(Ex.Obj).D[Ex.IndexValue]:=Ex.Args[0];
end;

class procedure TAIBDESQLHandler.I_SetF(Ex: TAIContext);
begin
  TBDESQL(Ex.Obj).F[Ex.IndexValue]:=Ex.Args[0];
end;

class procedure TAIBDESQLHandler.I_SetI(Ex: TAIContext);
begin
  TBDESQL(Ex.Obj).I[Ex.IndexValue]:=Ex.Args[0];
end;

class procedure TAIBDESQLHandler.I_SetM(Ex: TAIContext);
begin
  TBDESQL(Ex.Obj).M[Ex.IndexValue]:=Ex.Args[0];
end;

class procedure TAIBDESQLHandler.I_SetS(Ex: TAIContext);
begin
  TBDESQL(Ex.Obj).S[Ex.IndexValue]:=Ex.Args[0];
end;

class procedure TAIBDESQLHandler.I_SetT(Ex: TAIContext);
begin
  TBDESQL(Ex.Obj).T[Ex.IndexValue]:=Ex.Args[0];
end;

class procedure TAIBDESQLHandler.M_Add(Ex: TAIContext);
begin
  TBDESQL(Ex.Obj).Add(Ex.Args[0]);
end;

class procedure TAIBDESQLHandler.M_Close(Ex: TAIContext);
begin
  TBDESQL(Ex.Obj).Close();
end;

class procedure TAIBDESQLHandler.M_Edit(Ex: TAIContext);
begin
  TBDESQL(Ex.Obj).Edit();
end;

class procedure TAIBDESQLHandler.M_Exec(Ex: TAIContext);
begin
  TBDESQL(Ex.Obj).Exec();
end;

class procedure TAIBDESQLHandler.M_First(Ex: TAIContext);
begin
  TBDESQL(Ex.Obj).First();
end;

class procedure TAIBDESQLHandler.M_Last(Ex: TAIContext);
begin
  TBDESQL(Ex.Obj).Last();
end;

class procedure TAIBDESQLHandler.M_New(Ex: TAIContext);
begin
  TBDESQL(Ex.Obj).New();
end;

class procedure TAIBDESQLHandler.M_Next(Ex: TAIContext);
begin
  TBDESQL(Ex.Obj).Next();
end;

class procedure TAIBDESQLHandler.M_Open(Ex: TAIContext);
begin
  TBDESQL(Ex.Obj).Open();
end;

class procedure TAIBDESQLHandler.M_Post(Ex: TAIContext);
begin
  TBDESQL(Ex.Obj).Post();
end;

class procedure TAIBDESQLHandler.M_Prepare(Ex: TAIContext);
begin
  TBDESQL(Ex.Obj).Prepare();
end;

class procedure TAIBDESQLHandler.M_Prior(Ex: TAIContext);
begin
  TBDESQL(Ex.Obj).Prior();
end;

class procedure TAIBDESQLHandler.M_Refresh(Ex: TAIContext);
begin
  TBDESQL(Ex.Obj).Refresh();
end;

initialization
  RegisterHandler(TAIBDE,   TAIBDEHandler.Create());
  RegisterHandler(TBDESQL,  TAIBDESQLHandler.Create());

  AIBDE:=TAIBDE.Create(Application);
end.
