unit ARDBOpen;
//************************************************************//
//                         AND Report                        //
//  Eugene Hrulev (mrHru) Laxian Key, Omsk, Russia 1999,2001 //
//  Oleg Melnikov (muler) Laxian Key, Omsk, Russia 1999,2001 //
//************************************************************//

{$INCLUDE DEFINES.INC}

interface

uses
  Classes,
  {$IFDEF CLX}
    QStdCtrls, QControls, QButtons, QExtCtrls,
  {$ELSE}
    Windows, Forms, StdCtrls, Controls, Buttons, ExtCtrls, DBTables,
  {$ENDIF}

  ARSQL, ARResStrings;

type
  TDBOpenDlg = class(TForm)
    Bevel1: TBevel;
    OkBtn: TBitBtn;
    CancelBtn: TBitBtn;
    FilesLB: TComboBox;
    Bevel2: TBevel;
    procedure OkBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
  public
    FileName    :string;
    Database    :TDatabase;
    TableName   :string;
    function    Execute:boolean;
  end;

implementation

{$R *.dfm}

function    TDBOpenDlg.Execute:boolean;
begin
  FilesLB.Text:=FileName;
  ShowModal;
  Result:=ModalResult = mrOK;
end;

procedure TDBOpenDlg.OkBtnClick(Sender: TObject);
begin
  FileName:=FilesLB.Text;
  ModalResult:=mrOK;
end;

procedure TDBOpenDlg.CancelBtnClick(Sender: TObject);
begin
  ModalResult:=mrCancel;
end;

procedure TDBOpenDlg.FormShow(Sender: TObject);
var Q:TSQL;
begin
  FilesLB.Clear;
  Q:=TSQL.CreateDB(Database);
  try
    Q.Add('SELECT NAME FROM ' + TableName);
    Q.Open;
    while not Q.EOF do begin
      FilesLB.Items.Add(Q.S['NAME']);
      Q.Next;
    end;
    FilesLB.Text:=FileName;
  finally
    Q.Free;
  end;
end;

procedure TDBOpenDlg.FormCreate(Sender: TObject);
begin
  Caption           :=rsARDBOpen_Caption;
  OkBtn.Caption     :=rsAR_OkCaption;
  CancelBtn.Caption :=rsAR_CancelCaption;
end;

end.
