unit AREditorOptions;
//************************************************************//
//                         AND Report                        //
//  Eugene Hrulev (mrHru) Laxian Key, Omsk, Russia 1999,2001 //
//  Oleg Melnikov (muler) Laxian Key, Omsk, Russia 1999,2001 //
//************************************************************//

{$INCLUDE DEFINES.INC}

interface

uses
  SysUtils, Classes,
  {$IFDEF CLX}
    QStdCtrls, QButtons, QControls, QComCtrls, QForms,
  {$ELSE}
    StdCtrls, Buttons, Controls, ComCtrls, Forms,

    Windows, Messages, Graphics, Dialogs,
    ExtCtrls, Menus,
  {$ENDIF}

  ARResStrings, ARUtils, ARRepCommon;

type
  TARPreferecesDlg = class(TForm)
    PageControl1: TPageControl;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    EditorTabSheet: TTabSheet;
    GridXLabel: TLabel;
    GridYLabel: TLabel;
    GridXEdit: TEdit;
    GridYEdit: TEdit;
    UnitLabel1: TLabel;
    UnitLabel2: TLabel;
    procedure OKBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure RegCBClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    fChanged:boolean;
  public
    Units         :TARUnits;

    GridX         :extended;
    GridY         :extended;
  end;

implementation

uses AREditorMain;

{$R *.dfm}

procedure TARPreferecesDlg.CancelBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TARPreferecesDlg.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TARPreferecesDlg.OKBtnClick(Sender: TObject);
var Edit:TEdit;
begin
  Edit:=GridXEdit;
  try
                      GridX    :=StrToFloat(Edit.Text);
    Edit:=GridYEdit;  GridY    :=StrToFloat(Edit.Text);
  except
    Edit.SelectAll;
    Edit.SetFocus;
    exit;
  end;
end;

procedure TARPreferecesDlg.RegCBClick(Sender: TObject);
begin
  fChanged:=true;
end;

procedure TARPreferecesDlg.FormShow(Sender: TObject);
begin
  GridXEdit.Text    :=Format('%.2f', [GridX]);
  GridYEdit.Text    :=Format('%.2f', [GridY]);
  UnitLabel1.Caption:=UnitsShortName(Units);
  UnitLabel2.Caption:=UnitsShortName(Units);
end;

procedure TARPreferecesDlg.FormCreate(Sender: TObject);
begin
  Caption                 :=rsAREditorOptions_ARPreferecesDlgCaption;
  EditorTabSheet.Caption  :=rsAREditorOptions_EditorTabSheetCaption;
  GridXLabel.Caption      :=rsAREditorOptions_GridXLabelCaption;
  GridYLabel.Caption      :=rsAREditorOptions_GridYLabelCaption;
  OKBtn.Caption           :=rsAR_OkCaption;
  CancelBtn.Caption       :=rsAR_CancelCaption;
end;

end.
