unit AREditorUserVarList;
//************************************************************//
//                         AND Report                        //
//  Eugene Hrulev (mrHru) Laxian Key, Omsk, Russia 1999,2001 //
//  Oleg Melnikov (muler) Laxian Key, Omsk, Russia 1999,2001 //
//************************************************************//

{$INCLUDE DEFINES.INC}

interface

uses
  SysUtils, Classes,
  {$IFDEF CLX}
    QMenus, QTypes, QControls, QComCtrls, QStdCtrls, QButtons, QForms,
  {$ELSE}
    Windows, Forms, Messages, Graphics, Controls, Dialogs,
    Menus, StdCtrls, Buttons, ExtCtrls, IniFiles, Grids, ComCtrls,
  {$ENDIF}

  ARUtils, ARResStrings;

type
  TUserVarListDialog = class(TForm)
    AddBtn: TBitBtn;
    DeleteBtn: TBitBtn;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    PopupMenu: TPopupMenu;
    AddMenuItem: TMenuItem;
    DeleteMenuItem: TMenuItem;
    UserVarListLV: TListView;
    procedure AddBtnClick(Sender: TObject);
    procedure DeleteBtnClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
  public
    Objects   :TAIStringList;
  end;

implementation

{$R *.dfm}

procedure TUserVarListDialog.FormShow(Sender: TObject);
var li:TListItem;
    i:integer;
begin
  for i:=0 to Objects.Count - 1 do begin
    li:=UserVarListLV.Items.Add();
    li.Caption:=Objects[i];
  end;
end;

procedure TUserVarListDialog.FormDestroy(Sender: TObject);
begin
  Objects.Free;
end;

procedure TUserVarListDialog.AddBtnClick(Sender: TObject);
var li:TListItem;
begin
  li:=UserVarListLV.Items.Add();
  li.Caption:=rsAREditorUserVarList_NewObject;
  li.Focused:=true;
end;

procedure TUserVarListDialog.DeleteBtnClick(Sender: TObject);
begin
  if Assigned(UserVarListLV.Selected) then begin
    UserVarListLV.Items.Delete(UserVarListLV.Selected.Index);
  end;
end;

procedure TUserVarListDialog.OKBtnClick(Sender: TObject);
var i:integer;
begin
  Objects.Clear;
  for i:=0 to UserVarListLV.Items.Count - 1 do begin
    Objects.Add(UserVarListLV.Items[i].Caption);
  end;

  ModalResult:=mrOK;
end;

procedure TUserVarListDialog.CancelBtnClick(Sender: TObject);
begin
  ModalResult:=mrCancel;
end;

procedure TUserVarListDialog.FormCreate(Sender: TObject);
begin
  Objects:=TAIStringList.Create('TObjectsDialog.Objects');

  Caption               :=rsAREditorUserVarList_Caption;
  AddBtn.Caption        :=rsAREditorUserVarList_AddBtn;
  DeleteBtn.Caption     :=rsAREditorUserVarList_DeleteBtn;
  AddMenuItem.Caption   :=rsAREditorUserVarList_AddMenuItem;
  DeleteMenuItem.Caption:=rsAREditorUserVarList_DeleteMenuItem;

  OKBtn.Caption         :=rsAR_OkCaption;
  CancelBtn.Caption     :=rsAR_CancelCaption;
end;

end.
