unit ARReportPreview;
//************************************************************//
//                         AND Report                        //
//  Eugene Hrulev (mrHru) Laxian Key, Omsk, Russia 1999,2001 //
//  Oleg Melnikov (muler) Laxian Key, Omsk, Russia 1999,2001 //
//************************************************************//

{$INCLUDE DEFINES.INC}

interface

uses
  Classes, ExtCtrls, Menus, ComCtrls, StdCtrls, Controls, Buttons, ToolWin,
  Forms, Graphics, DB, SysUtils, Dialogs, Windows,

  ARRepCommon, ARRep, ARGridRep, ARUserRep, ARResStrings;

type
  TReportPreviewDlg = class(TForm)
    ToolBar: TToolBar;
    ToolButton14: TToolButton;
    ToolButton13: TToolButton;
    Panel1: TPanel;
    CopiesEdit: TEdit;
    CopiesUpDown: TUpDown;
    RepPopupMenu: TPopupMenu;
    PrintMenuItem: TMenuItem;
    PrintSetupMenuItem: TMenuItem;
    Copy1MenuItem: TMenuItem;
    Copy2MenuItem: TMenuItem;
    Copy3MenuItem: TMenuItem;
    Copy4MenuItem: TMenuItem;
    Copy5MenuItem: TMenuItem;
    Copy6MenuItem: TMenuItem;
    Copy7MenuItem: TMenuItem;
    Copy8MenuItem: TMenuItem;
    Copy9MenuItem: TMenuItem;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    SB: TStatusBar;
    ProgressPanel: TPanel;
    PB: TProgressBar;
    TimeLabel: TLabel;
    Timer: TTimer;
    PreviewBtn: TSpeedButton;
    PrintBtn: TSpeedButton;
    PrintQueryBtn: TSpeedButton;
    PrinterSetupBtn: TSpeedButton;
    CloseBtn: TSpeedButton;
    AbortBtn: TSpeedButton;
    PrintQueryMenuItem: TMenuItem;
    CloseBtnToo: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure PrinterSetupBtnClick(Sender: TObject);
    procedure PrintBtnClick(Sender: TObject);
    procedure CopiesEditChange(Sender: TObject);
    procedure Copy1MenuItemClick(Sender: TObject);
    procedure Copy2MenuItemClick(Sender: TObject);
    procedure Copy3MenuItemClick(Sender: TObject);
    procedure Copy4MenuItemClick(Sender: TObject);
    procedure Copy5MenuItemClick(Sender: TObject);
    procedure Copy6MenuItemClick(Sender: TObject);
    procedure Copy7MenuItemClick(Sender: TObject);
    procedure Copy8MenuItemClick(Sender: TObject);
    procedure Copy9MenuItemClick(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure PreviewBtnClick(Sender: TObject);
    procedure AbortBtnClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure PrintQueryBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    InWork      :boolean;
    TimeCounter :cardinal;
    fPrinted    :boolean;

    FTemplate   :string;
    FTerminated :boolean;

    FAutoStep   :boolean;
    FProcessMessages:boolean;

    procedure   SetTemplate(ATemplate:string);

    function    GetS(VarName:string):string;
    procedure   SetS(VarName:string; VarValue:string);

    function    GetF(VarName:string):extended;
    procedure   SetF(VarName:string; VarValue:extended);

    function    GetC(VarName:string):currency;
    procedure   SetC(VarName:string; VarValue:currency);

    procedure   SetM(VarName:string; VarValue:extended);
    procedure   SetM4(VarName:string; VarValue:extended);

    function    GetI(VarName:string):integer;
    procedure   SetI(VarName:string; VarValue:integer);

    function    GetD(VarName:string):TDateTime;
    procedure   SetD(VarName:string; VarValue:TDateTime);

    function    GetT(VarName:string):TDateTime;
    procedure   SetT(VarName:string; VarValue:TDateTime);

    function    GetG(VarName:string):TGraphic;
    procedure   SetG(VarName:string; VarValue:TGraphic);

    function    GetU(VarName:string):integer;
    procedure   SetU(VarName:string; VarValue:integer);

    function    GetTitle:string;
    procedure   SetTitle(ATitle:string);

    function    GetRecordCount:integer;
    procedure   SetRecordCount(ARecordCount:integer);

    function    GetFixedBands:integer;
    procedure   SetFixedBands(AFixedBands:integer);
    procedure CalcSelectedSumma;
    procedure repSelectCell(Sender: TObject; IdxBand, IdxCell: Integer);
  public
    property    S[VarName:string]:string      read  GetS  write SetS;
    property    F[VarName:string]:extended    read  GetF  write SetF;
    property    I[VarName:string]:integer     read  GetI  write SetI;
    property    D[VarName:string]:TDateTime   read  GetD  write SetD;
    property    T[VarName:string]:TDateTime   read  GetT  write SetT;
    property    M[VarName:string]:extended                write SetM;
    property    M4[VarName:string]:extended               write SetM4;
    property    C[VarName:string]:currency    read  GetC  write SetC;
    property    G[VarName:string]:TGraphic    read  GetG  write SetG;

    function    Cells(IdxBand:integer; IdxCell:integer):TARCell;

    procedure   SetDSValues(DS:TDataSet);

    property    U[VarName:string]:integer     read  GetU  write SetU;

    procedure   Load(ATemplate:string);

{$IFDEF D3}
    function    AddBands(BandName:string):TARBand;
{$ELSE}
    function    AddBands(BandName:string; ToBand:TARBand = nil; Expanded:boolean = true):TARBand;
{$ENDIF}
    function    AddSubBands(BandName:string; Expanded:boolean):TARBand;
    function    AddSubBandsToBand(BandName:string; ToBand:TARBand; Expanded:boolean):TARBand;

{$IFDEF D3}
    function    AddGroupBands(const BandName:string; Value:variant):TARBand;
    function    AddGroupBandsToBand(const BandName:string; Value:variant; ToBand:TARBand; Expanded:boolean):TARBand;
{$ELSE}
    function    AddGroupBands(const BandName:string; Value:variant; ToBand:TARBand = nil; Expanded:boolean = true):TARBand;
{$ENDIF}
    function    NewGroup(const BandName:string; Value:variant):boolean;

    procedure   InsertBands(InsertIdxBand:integer; BandName:string);
    procedure   DeleteBand(IdxBand:integer);
    procedure   DeleteBands;
    procedure   ClearValues;
    procedure   PageBreak;
    procedure   ShowMsg(s:string);
    procedure   StepIt;

    procedure   StartWork;
    procedure   StopWork;

    procedure   Preview;

{$IFDEF D3}
    constructor Create(AOwner:TComponent; ATemplate:string);
{$ELSE}
    constructor Create(AOwner:TComponent; ATemplate:string);reintroduce;
{$ENDIF}
  published
    rep         :TARUserRep;

    property    Template:string               read  FTemplate         write SetTemplate;
    property    Terminated:boolean            read  FTerminated       write FTerminated;
    property    AutoStep:boolean              read  FAutoStep         write FAutoStep;
    property    ProcessMessages:boolean       read  FProcessMessages  write FProcessMessages;

    property    RecordCount:integer           read  GetRecordCount    write SetRecordCount;

    property    Title:string                  read  GetTitle          write SetTitle;
    property    Path:string                   read  FTemplate         write SetTemplate;
    property    FixedBands:integer            read  GetFixedBands     write SetFixedBands;
  end;

implementation

{$R *.dfm}

constructor TReportPreviewDlg.Create(AOwner:TComponent; ATemplate:string);
begin
  inherited Create(AOwner);

  Template:=ATemplate;
end;

procedure TReportPreviewDlg.CopiesEditChange(Sender: TObject);
begin
  rep.prn.Copies:=CopiesUpDown.Position;
end;

procedure TReportPreviewDlg.Copy1MenuItemClick(Sender: TObject);
begin
  CopiesUpDown.Position:=1;
end;

procedure TReportPreviewDlg.Copy2MenuItemClick(Sender: TObject);
begin
  CopiesUpDown.Position:=2;
end;

procedure TReportPreviewDlg.Copy3MenuItemClick(Sender: TObject);
begin
  CopiesUpDown.Position:=3;
end;

procedure TReportPreviewDlg.Copy4MenuItemClick(Sender: TObject);
begin
  CopiesUpDown.Position:=4;
end;

procedure TReportPreviewDlg.Copy5MenuItemClick(Sender: TObject);
begin
  CopiesUpDown.Position:=5;
end;

procedure TReportPreviewDlg.Copy6MenuItemClick(Sender: TObject);
begin
  CopiesUpDown.Position:=6;
end;

procedure TReportPreviewDlg.Copy7MenuItemClick(Sender: TObject);
begin
  CopiesUpDown.Position:=7;
end;

procedure TReportPreviewDlg.Copy8MenuItemClick(Sender: TObject);
begin
  CopiesUpDown.Position:=8;
end;

procedure TReportPreviewDlg.Copy9MenuItemClick(Sender: TObject);
begin
  CopiesUpDown.Position:=9;
end;

procedure    TReportPreviewDlg.InsertBands(InsertIdxBand:integer; BandName:string);
begin
  rep.InsertBands(InsertIdxBand, BandName);
  SB.Panels[0].Text:=IntToStr(rep.SrcRep.BandCount);
  if AutoStep then PB.StepIt;
  if ProcessMessages then Application.ProcessMessages;
end;

{$IFDEF D3}
function    TReportPreviewDlg.AddGroupBands(const BandName:string; Value:variant):TARBand;
begin
  Result:=AddGroupBandsToBand(BandName, Value, nil, true);
end;

function    TReportPreviewDlg.AddGroupBandsToBand(const BandName:string; Value:variant; ToBand:TARBand; Expanded:boolean):TARBand;
begin
  Result:=rep.AddGroupBandsToBand(BandName, Value, ToBand, Expanded);
  SB.Panels[0].Text:=IntToStr(rep.SrcRep.BandCount);
  if AutoStep then PB.StepIt;
  if ProcessMessages then Application.ProcessMessages;
end;
{$ELSE}
function    TReportPreviewDlg.AddGroupBands(const BandName:string; Value:variant; ToBand:TARBand = nil; Expanded:boolean = true):TARBand;
begin
  Result:=rep.AddGroupBands(BandName, Value, ToBand, Expanded);
  SB.Panels[0].Text:=IntToStr(rep.SrcRep.BandCount);
  if AutoStep then PB.StepIt;
  if ProcessMessages then Application.ProcessMessages;
end;
{$ENDIF}

function    TReportPreviewDlg.NewGroup(const BandName:string; Value:variant):boolean;
begin
  Result:=rep.NewGroup(BandName, Value);
end;

{$IFDEF D3}
function    TReportPreviewDlg.AddBands(BandName:string):TARBand;
begin
  Result:=rep.AddBands(BandName);
  SB.Panels[0].Text:=IntToStr(rep.SrcRep.BandCount);
  if AutoStep then PB.StepIt;
  if ProcessMessages then Application.ProcessMessages;
end;
{$ELSE}
function    TReportPreviewDlg.AddBands(BandName:string; ToBand:TARBand = nil; Expanded:boolean = true):TARBand;
begin
  Result:=rep.AddBands(BandName, ToBand, Expanded);
  SB.Panels[0].Text:=IntToStr(rep.SrcRep.BandCount);
  if AutoStep then PB.StepIt;
  if ProcessMessages then Application.ProcessMessages;
end;
{$ENDIF}

function    TReportPreviewDlg.AddSubBands(BandName:string; Expanded:boolean):TARBand;
begin
  Result:=rep.AddSubBands(BandName, Expanded);
  if Expanded then begin
    SB.Panels[0].Text:=IntToStr(rep.SrcRep.BandCount);
    if AutoStep then PB.StepIt;
    if ProcessMessages then Application.ProcessMessages;
  end;
end;

function    TReportPreviewDlg.AddSubBandsToBand(BandName:string; ToBand:TARBand; Expanded:boolean):TARBand;
begin
	Result:=rep.AddSubBandsToBand(BandName, ToBand, Expanded);
end;

procedure   TReportPreviewDlg.StepIt;
begin
  PB.StepIt;
end;

procedure    TReportPreviewDlg.DeleteBand(IdxBand:integer);
begin
  rep.DeleteBand(IdxBand);
end;

procedure    TReportPreviewDlg.DeleteBands;
begin
  rep.DeleteBands;
  SB.Panels[0].Text:=IntToStr(rep.SrcRep.BandCount);
  PB.Position:=0;
end;

procedure    TReportPreviewDlg.ClearValues;
begin
  rep.ClearValues;
end;

procedure   TReportPreviewDlg.PageBreak;
begin
  rep.PageBreak;
end;
//////////////////////////////////////////////////////
function    TReportPreviewDlg.GetS(VarName:string):string;
begin
  Result:=rep.S[VarName];
end;
function    TReportPreviewDlg.GetF(VarName:string):extended;
begin
  Result:=rep.F[VarName];
end;
function    TReportPreviewDlg.GetC(VarName:string):currency;
begin
  Result:=rep.C[VarName];
end;
function    TReportPreviewDlg.GetI(VarName:string):integer;
begin
  Result:=rep.I[VarName];
end;
function    TReportPreviewDlg.GetD(VarName:string):TDateTime;
begin
  Result:=rep.D[VarName];
end;
function    TReportPreviewDlg.GetT(VarName:string):TDateTime;
begin
  Result:=rep.T[VarName];
end;

procedure   TReportPreviewDlg.SetS(VarName:string; VarValue:string);
begin
  rep.S[VarName]:=VarValue;
end;
procedure   TReportPreviewDlg.SetF(VarName:string; VarValue:extended);
begin
  rep.F[VarName]:=VarValue;
end;
procedure   TReportPreviewDlg.SetC(VarName:string; VarValue:currency);
begin
  rep.C[VarName]:=VarValue;
end;
procedure   TReportPreviewDlg.SetM(VarName:string; VarValue:extended);
var DS:char;
begin
  DS:=DecimalSeparator;
  try
    DecimalSeparator:='-';
    rep.S[VarName]:=Format('%.2f', [VarValue]);
  finally
    DecimalSeparator:=DS;
  end;
end;
procedure   TReportPreviewDlg.SetM4(VarName:string; VarValue:extended);
var DS:char;
begin
  DS:=DecimalSeparator;
  try
    DecimalSeparator:='-';
    rep.S[VarName]:=Format('%.4f', [VarValue]);
  finally
    DecimalSeparator:=DS;
  end;
end;
procedure   TReportPreviewDlg.SetI(VarName:string; VarValue:integer);
begin
  rep.I[VarName]:=VarValue;
end;
procedure   TReportPreviewDlg.SetD(VarName:string; VarValue:TDateTime);
begin
  rep.D[VarName]:=VarValue;
end;
procedure   TReportPreviewDlg.SetT(VarName:string; VarValue:TDateTime);
begin
  rep.T[VarName]:=VarValue;
end;

function    TReportPreviewDlg.GetG(VarName:string):TGraphic;
begin
  Result:=rep.G[VarName];
end;

procedure   TReportPreviewDlg.SetG(VarName:string; VarValue:TGraphic);
begin
  rep.G[VarName]:=VarValue;
end;

function    TReportPreviewDlg.GetU(VarName:string):integer;
begin
  Result:=rep.U[VarName];
end;
procedure   TReportPreviewDlg.SetU(VarName:string; VarValue:integer);
begin
  rep.U[VarName]:=VarValue;
end;

function    TReportPreviewDlg.GetTitle:string;
begin
  Result:=rep.Title;
end;

procedure   TReportPreviewDlg.SetDSValues(DS:TDataSet);
begin
  rep.SetDSValues(DS);
end;

procedure   TReportPreviewDlg.SetTitle(ATitle:string);
begin
  rep.Title:=ATitle;
  Caption:=ATitle;
end;

procedure    TReportPreviewDlg.ShowMsg(s:string);
begin
  SB.Panels[1].Text:=s;
  Application.Processmessages;
end;

procedure TReportPreviewDlg.CloseBtnClick(Sender: TObject);
begin
  if InWork and (not Terminated)then begin
    if MessageDlg(rsARReportPreview_AbortQuery, mtConfirmation, mbOKCancel, 0) = mrOK then begin
      Terminated:=true;
    end;
  end else begin
    Close;
  end;
end;

procedure    TReportPreviewDlg.StartWork;
begin
  CloseBtn.Visible:=false;
//  CloseBtnToo.Visible:=false;
  AbortBtn.Visible  :=true;
  InWork:=true;
  TimeCounter:=GetTickCount;
end;

procedure    TReportPreviewDlg.StopWork;
begin
  CloseBtn.Visible:=true;
//  CloseBtnToo.Visible:=true;
  AbortBtn.Visible  :=false;
  InWork:=false;
  TimeCounter:=0;
end;

procedure TReportPreviewDlg.AbortBtnClick(Sender: TObject);
begin
  if InWork and (not Terminated)then begin
    if MessageDlg(rsARReportPreview_AbortQuery, mtConfirmation, mbOKCancel, 0) = mrOK then begin
      Terminated:=true;
    end;
  end;
end;

procedure TReportPreviewDlg.TimerTimer(Sender: TObject);
begin
  inherited;
  if TimeCounter > 0 then begin
    if not fPrinted then begin
      TimeLabel.Caption:=Format('%d c.', [(GetTickCount - TimeCounter) div 1000]);
    end else begin
      SB.Panels[1].Text:=Format(rsARReportPreview_Printing,
                          [rep.prn.PageCount, rep.prn.Copies, (GetTickCount - TimeCounter) div 1000]);
    end;
  end;
end;

procedure TReportPreviewDlg.PrinterSetupBtnClick(Sender: TObject);
begin
  rep.prn.PrinterSetupDialog;

end;

procedure TReportPreviewDlg.PrintBtnClick(Sender: TObject);
begin
  rep.Print;
  fPrinted:=true;
  TimeCounter:=GetTickCount;
end;

procedure TReportPreviewDlg.PreviewBtnClick(Sender: TObject);
begin
  Preview();
end;

procedure TReportPreviewDlg.PrintQueryBtnClick(Sender: TObject);
begin
  rep.PrintDialog;
  fPrinted:=true;
  TimeCounter:=GetTickCount;
end;

procedure TReportPreviewDlg.repSelectCell(Sender: TObject; IdxBand, IdxCell: Integer);
begin
  CalcSelectedSumma();
end;

function  StrMoneyToCurrency(s:string; var IsMoney:boolean):currency;
var ss:string;
    sgn, p, code:integer;
    Value:extended;
begin
  sgn:=1;
  ss:=Trim(s);
  if (Length(ss) > 0) and (ss[1] = '-') then begin
    sgn:=-1;
    ss:=System.Copy(ss, 2, Length(ss));
  end;

  p:=System.Pos(' ', ss);
  while p > 0 do begin
    System.Delete(ss, p, 1);
    p:=System.Pos(' ', ss);
  end;

  p:=System.Pos(',', ss);
  if p > 0 then begin
    ss[p]:='.';
  end else begin
    p:=System.Pos('-', ss);
    if p > 0 then begin
      ss[p]:='.';
    end;
  end;
  System.Val(ss, Value, code);
  if code <> 0 then begin
    Result:=0.0;
    IsMoney:=false;
  end else begin
    Result:=Value * sgn;
    IsMoney:=true;
  end;
end;

procedure TReportPreviewDlg.CalcSelectedSumma();
var sum:currency;
    i:integer;
    IsMoney:boolean;
begin
  sum:=0.0;
  for i:=0 to Rep.SelCount - 1 do begin
    sum:=sum + StrMoneyToCurrency(TARCell(Rep.SelList[i]).Value, IsMoney);
  end;

  SB.Panels[1].Text:=Format('S = %f', [sum]);
end;

procedure   TReportPreviewDlg.FormCreate(Sender: TObject);
begin
  rep:=TARUserRep.Create(Self);
  rep.Parent          := Self;
  rep.Align           := alClient;
  rep.TabStop         := true;
  rep.TabOrder        := 0;
  rep.PopupMenu       := RepPopupMenu;
  rep.Units           := uPix;
  rep.Options         := [];
  rep.Color           := clBtnFace;
  rep.Gutter          := 20;
  rep.ShowBandTitle   := false;
  rep.ShowRightMargin := false;
  rep.ShowHiddenItems := false;
  rep.Columns         := 0;

  rep.OnSelectCell    := repSelectCell;

  CalcSelectedSumma();

  AbortBtn.Visible:=false;
  AutoStep:=true;
  ProcessMessages:=false;

  Caption                   :=rsARReportPreview_Caption;

  PreviewBtn.Hint           :=rsARReportPreview_PreviewBtn;
  PrintBtn.Hint             :=rsARReportPreview_PrintBtn;
  PrintQueryBtn.Hint        :=rsARReportPreview_PrintQueryBtn;
  PrinterSetupBtn.Hint      :=rsARReportPreview_PrinterSetupBtn;
  CloseBtn.Hint             :=rsAR_CloseCaption;
  AbortBtn.Hint             :=rsARReportPreview_AbortBtn;
  CopiesEdit.Hint           :=rsARReportPreview_CopiesEdit;
  CopiesUpDown.Hint         :=rsARReportPreview_CopiesUpDown;
  ProgressPanel.Hint        :=rsARReportPreview_ProgressPanel;

  PrintMenuItem.Caption     :=rsARReportPreview_PrintMenuItem;
  PrintQueryMenuItem.Caption:=rsARReportPreview_PrintQueryMenuItem;
  PrintSetupMenuItem.Caption:=rsARReportPreview_PrintSetupMenuItem;
  Copy1MenuItem.Caption     :=rsARReportPreview_Copy1MenuItem;
  Copy2MenuItem.Caption     :=rsARReportPreview_Copy2MenuItem;
  Copy3MenuItem.Caption     :=rsARReportPreview_Copy3MenuItem;
  Copy4MenuItem.Caption     :=rsARReportPreview_Copy4MenuItem;
  Copy5MenuItem.Caption     :=rsARReportPreview_Copy5MenuItem;
  Copy6MenuItem.Caption     :=rsARReportPreview_Copy6MenuItem;
  Copy7MenuItem.Caption     :=rsARReportPreview_Copy7MenuItem;
  Copy8MenuItem.Caption     :=rsARReportPreview_Copy8MenuItem;
  Copy9MenuItem.Caption     :=rsARReportPreview_Copy9MenuItem;

  rep.prn.Copies:=1;
end;

procedure   TReportPreviewDlg.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure   TReportPreviewDlg.Load(ATemplate:string);
begin
  FTemplate:=ATemplate;

  if Length(ATemplate) > 0 then begin
    rep.Load(ATemplate);
  end;
end;

procedure   TReportPreviewDlg.SetTemplate(ATemplate:string);
begin
  Load(ATemplate);
end;

procedure   TReportPreviewDlg.Preview();
begin
  rep.Preview();
end;

function    TReportPreviewDlg.Cells(IdxBand:integer; IdxCell:integer):TARCell;
begin
  Result:=rep.Cells(IdxBand, IdxCell);
end;

function    TReportPreviewDlg.GetRecordCount:integer;
begin
  Result:=PB.Max;
end;

procedure   TReportPreviewDlg.SetRecordCount(ARecordCount:integer);
begin
  PB.Max:=ARecordCount;
end;

function    TReportPreviewDlg.GetFixedBands:integer;
begin
  Result:=rep.FixedBands;
end;

procedure   TReportPreviewDlg.SetFixedBands(AFixedBands:integer);
begin
  rep.FixedBands:=AFixedBands;
end;

end.


