unit ARSelectDatabase;
//************************************************************//
//                         AND Report                        //
//  Eugene Hrulev (mrHru) Laxian Key, Omsk, Russia 1999,2001 //
//  Oleg Melnikov (muler) Laxian Key, Omsk, Russia 1999,2001 //
//************************************************************//

interface

uses
  Classes,
  {$IFDEF CLX}
    QStdCtrls, QControls, QButtons,
  {$ELSE}
    DBTables, StdCtrls, Controls, Buttons, Forms,
  {$ENDIF}

  ARResStrings;

type
  TSelectDBDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Aliases: TComboBox;
    procedure FormShow(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure AliasesKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
  public
    Database  :TDatabase;
    constructor  CreateDB(AOwner:TComponent; ADatabase:TDatabase);
  end;

implementation

{$R *.dfm}

constructor  TSelectDBDlg.CreateDB(AOwner:TComponent; ADatabase:TDatabase);
begin
  inherited Create(AOwner);

  Database:=ADatabase;
end;

procedure   TSelectDBDlg.FormShow(Sender: TObject);
begin
  Aliases.Items.Clear;
  Database.Session.GetAliasNames(Aliases.Items);
  Aliases.ItemIndex:=Aliases.Items.IndexOf(Database.AliasName);
end;

procedure   TSelectDBDlg.OKBtnClick(Sender: TObject);
begin
  Database.Close;
  Database.AliasName:=Aliases.Text;
  Database.Open;

  ModalResult:=mrOK;
end;

procedure   TSelectDBDlg.CancelBtnClick(Sender: TObject);
begin
  ModalResult:=mrCancel;
end;

procedure   TSelectDBDlg.AliasesKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #$0d then OKBtnClick(Sender);
end;

procedure TSelectDBDlg.FormCreate(Sender: TObject);
begin
  Caption           :=rsARSelectDatabase_Caption;
  OKBtn.Caption     :=rsAR_OkCaption;
  CancelBtn.Caption :=rsAR_CancelCaption;
end;

end.
