unit BarcodeRep;
//************************************************************//
//                         AND Report                        //
//  Eugene Hrulev (mrHru) Laxian Key, Osmk, Russia 1999,2000 //
//  Oleg Melnikov (muler) Laxian Key, Osmk, Russia 1999,2000 //
//************************************************************//

interface

uses
  SysUtils, Forms, Dialogs,

  ARSQL, ARUserRep, Barcode, ARBarcode;

procedure BarcodeReport(Rep: TARUserRep; BC: TARBarcode);

implementation

uses Main;

procedure BarcodeReport(Rep: TARUserRep; BC: TARBarcode);
begin
	Rep.Load(ExtractFilePath(ParamStr(0)) + 'BarCode.ar');
  Rep.Title:='BarCode report';

	Rep.S['Code1']       :='12345';
	Rep.S['Code2']       :='54321';

	Rep.AddBands('Header');

  // set common values for all bands
  BC['Barcode1'].Text:='12345';
  BC['Barcode2'].Text:='54321';

	Rep.S['Name']:='CodeEAN128C';
  BC['Barcode1'].Typ:=bcCodeEAN128C;
  BC['Barcode2'].Typ:=bcCodeEAN128C;
	Rep.AddBands('Band');

	Rep.S['Name']:='Code_2_5_interleaved';
  BC['Barcode1'].Typ:=bcCode_2_5_interleaved;
  BC['Barcode2'].Typ:=bcCode_2_5_interleaved;
	Rep.AddBands('Band');

	Rep.S['Name']:='Code_2_5_industrial';
  BC['Barcode1'].Typ:=bcCode_2_5_industrial;
  BC['Barcode2'].Typ:=bcCode_2_5_industrial;
	Rep.AddBands('Band');

	Rep.S['Name']:='Code_2_5_matrix';
  BC['Barcode1'].Typ:=bcCode_2_5_matrix;
  BC['Barcode2'].Typ:=bcCode_2_5_matrix;
	Rep.AddBands('Band');

	Rep.S['Name']:='Code39';
  BC['Barcode1'].Typ:=bcCode39;
  BC['Barcode2'].Typ:=bcCode39;
	Rep.AddBands('Band');

	Rep.S['Name']:='Code39Extended';
  BC['Barcode1'].Typ:=bcCode39Extended;
  BC['Barcode2'].Typ:=bcCode39Extended;
	Rep.AddBands('Band');

	Rep.S['Name']:='Code128A';
  BC['Barcode1'].Typ:=bcCode128A;
  BC['Barcode2'].Typ:=bcCode128A;
	Rep.AddBands('Band');

	Rep.S['Name']:='Code128B';
  BC['Barcode1'].Typ:=bcCode128B;
  BC['Barcode2'].Typ:=bcCode128B;
	Rep.AddBands('Band');

	Rep.S['Name']:='Code128C';
  BC['Barcode1'].Typ:=bcCode128C;
  BC['Barcode2'].Typ:=bcCode128C;
	Rep.AddBands('Band');

	Rep.S['Name']:='Code93';
  BC['Barcode1'].Typ:=bcCode93;
  BC['Barcode2'].Typ:=bcCode93;
	Rep.AddBands('Band');

	Rep.S['Name']:='Code93Extended';
  BC['Barcode1'].Typ:=bcCode93Extended;
  BC['Barcode2'].Typ:=bcCode93Extended;
	Rep.AddBands('Band');

	Rep.S['Name']:='CodeMSI';
  BC['Barcode1'].Typ:=bcCodeMSI;
  BC['Barcode2'].Typ:=bcCodeMSI;
	Rep.AddBands('Band');

	Rep.S['Name']:='CodePostNet';
  BC['Barcode1'].Typ:=bcCodePostNet;
  BC['Barcode2'].Typ:=bcCodePostNet;
	Rep.AddBands('Band');

	Rep.S['Name']:='CodeCodabar';
  BC['Barcode1'].Typ:=bcCodeCodabar;
  BC['Barcode2'].Typ:=bcCodeCodabar;
	Rep.AddBands('Band');

	Rep.S['Name']:='CodeEAN8';
  BC['Barcode1'].Typ:=bcCodeEAN8;
  BC['Barcode2'].Typ:=bcCodeEAN8;
	Rep.AddBands('Band');

	Rep.S['Name']:='CodeEAN13';
  BC['Barcode1'].Typ:=bcCodeEAN13;
  BC['Barcode2'].Typ:=bcCodeEAN13;
	Rep.AddBands('Band');

	Rep.S['Name']:='CodeUPC_A';
  BC['Barcode1'].Typ:=bcCodeUPC_A;
  BC['Barcode2'].Typ:=bcCodeUPC_A;
	Rep.AddBands('Band');

	Rep.S['Name']:='CodeUPC_E0';
  BC['Barcode1'].Typ:=bcCodeUPC_E0;
  BC['Barcode2'].Typ:=bcCodeUPC_E0;
	Rep.AddBands('Band');

	Rep.S['Name']:='CodeUPC_E1';
  BC['Barcode1'].Typ:=bcCodeUPC_E1;
  BC['Barcode2'].Typ:=bcCodeUPC_E1;
	Rep.AddBands('Band');

	Rep.S['Name']:='CodeUPC_Supp2';
  BC['Barcode1'].Typ:=bcCodeUPC_Supp2;
  BC['Barcode2'].Typ:=bcCodeUPC_Supp2;
	Rep.AddBands('Band');

	Rep.S['Name']:='CodeUPC_Supp5';
  BC['Barcode1'].Typ:=bcCodeUPC_Supp5;
  BC['Barcode2'].Typ:=bcCodeUPC_Supp5;
	Rep.AddBands('Band');

	Rep.S['Name']:='CodeEAN128A';
  BC['Barcode1'].Typ:=bcCodeEAN128A;
  BC['Barcode2'].Typ:=bcCodeEAN128A;
	Rep.AddBands('Band');

	Rep.S['Name']:='CodeEAN128B';
  BC['Barcode1'].Typ:=bcCodeEAN128B;
  BC['Barcode2'].Typ:=bcCodeEAN128B;
	Rep.AddBands('Band');

	Rep.S['Name']:='CodeEAN128C';
  BC['Barcode1'].Typ:=bcCodeEAN128C;
  BC['Barcode2'].Typ:=bcCodeEAN128C;
	Rep.AddBands('Band');

  Rep.FixedBands:=1;
end;

end.
