unit Biolife;
//************************************************************//
//                         AND Report                        //
//  Eugene Hrulev (mrHru) Laxian Key, Omsk, Russia 1999,2001 //
//  Oleg Melnikov (muler) Laxian Key, Omsk, Russia 1999,2001 //
//************************************************************//

{$INCLUDE DEFINES.INC}

interface

uses
  SysUtils, Classes,
  {$IFDEF CLX}
  {$ELSE}
    ARSQL,
  {$ENDIF} 
  ARUserRep;

procedure BiolifeReport(Rep: TARUserRep);

implementation

uses Main;

procedure BiolifeReport(Rep: TARUserRep);
{$IFDEF CLX}
{$ELSE}
var Q:TSQL;
{$ENDIF}
begin
	Rep.Load(ExtractFilePath(ParamStr(0)) + '\Biolife.ar'); //  load template
  Rep.Title:='Biolife report';                            //  set print job title
	Rep.AddBands('Title');                                  //  add title bands

  {$IFDEF CLX}
  {$ELSE}
    Q:=TSQL.CreateDB(DemoDlg.Database1);                    //
    try                                                     //  create and open query
      Q.Add('SELECT * FROM BIOLIFE');                       //
      Q.Open;                                               //
      DemoDlg.ProgressBar.Position:=0;
      DemoDlg.ProgressBar.Max:=Q.RecordCount;

      while not Q.EOF do begin                              //  main loop
  //      Rep.BeginPara;                                      //  mark follow bands as non breaking group
  {
        Rep.I['SpeciesNo']	:=Q.I['Species No'];                  //  assign values as integer
        Rep.S['Category']		:=Q.S['Category'];                    //  ... as string
        Rep.S['CommonName']	:=Q.S['Common_Name'];                 //  ... as string
        Rep.S['SpeciesName']:=Q.S['Species Name'];                //  ... as string
        Rep.F['LengthCM']		:=Q.F['Length (cm)'];                 //  ... as double
        Rep.S['LengthIN']		:=Format('%.2f', [Q.F['Length_In']]); //  ... as string
        Rep.S['Notes']			:=Q.S['Notes'];                       //  ... as string
        Rep.G['Graphic']		:=Q.G['Graphic'];                     //  ... as TGraphic
  }
        Rep.SetDSValues(Q.DataSet);                         //  assign values from all TDataSet.Fields
                                                            //  using field type info

        Rep.RTF['Notes']	:=Q.S['Notes'];
        Rep.F['LengthCM'] :=Q.F['Length (cm)'];

        Rep.AddBands('Band');                               //  add bands 'Band' into report

  //      Rep.EndPara;

        Q.Next;
        DemoDlg.ProgressBar.StepIt;                         //  show job progress
      end;
    finally
      Q.Free;
    end;
  {$ENDIF}

  Rep.FixedBands:=1;                                      //  set top nonscrolling region
end;

end.
