unit Calendar;
//************************************************************//
//                         AND Report                        //
//  Eugene Hrulev (mrHru) Laxian Key, Omsk, Russia 1999,2001 //
//  Oleg Melnikov (muler) Laxian Key, Omsk, Russia 1999,2001 //
//************************************************************//

{$INCLUDE DEFINES.INC}

interface

uses
  SysUtils,
  {$IFDEF CLX}
  {$ELSE}
    Forms, Dialogs,
  {$ENDIF}

  ARUserRep;

procedure CalendarReport(Rep: TARUserRep);

implementation

uses Main;

procedure CalendarReport(Rep: TARUserRep);
var Year, Month, Day:word;
    NewMonth, NewDay:word;
    n, DOW:integer;
begin
  DecodeDate(Now, Year, Month, Day);
	Rep.Load(ExtractFilePath(ParamStr(0)) + 'Calendar.ar');
  Rep.Title:='Calendar report';
  Rep.I['Year']:=Year;
	Rep.AddBands('Title');

  Month :=0;
  DOW   :=0;
  for n:=Trunc(EncodeDate(Year, 1, 1)) to Trunc(EncodeDate(Year, 12, 31)) do begin
    DecodeDate(n, Year, NewMonth, NewDay);
    if NewMonth <> Month then begin
      if not (DOW in [0, 7]) then Rep.AddBands('Band');
      
      Rep.BeginPara;
      Rep.S['Month']:=FormatDateTime('mmmm', n);
      Rep.AddBands('Month');

      for Day:=1 to 7 do begin
        DOW:=DayOfWeek(EncodeDate(Year, NewMonth, Day));
        Rep.S['w' + Chr(Ord('0') + DOW)]:=FormatDateTime('ddd', EncodeDate(Year, NewMonth, Day));
      end;
    	Rep.AddBands('Week');
      Rep.ClearValues;
    end;

    DOW:=DayOfWeek(n);
    Rep.I['d' + Chr(Ord('0') + DOW)]:=NewDay;
    if DOW = 7 then begin
      Rep.AddBands('Band');
      Rep.ClearValues;
    end;

    if NewMonth <> Month then begin
      Month:=NewMonth;
      Rep.AddBands('EndMonth');
    end;
  end;
  if not (DOW in [0, 7]) then Rep.AddBands('Band');
  Rep.AddBands('EndMonth');

  Rep.FixedBands:=1;
  Rep.Columns:=2;
end;

end.

