unit Editable;
//************************************************//
//                   AND Report                  //
//  Eugene Hrulev (mrHru) Osmk, Russia 1999,2000 //
//  Oleg Melnikov (muler) Osmk, Russia 1999,2000 //
//************************************************//

interface

uses
  SysUtils,

  ARRepCommon, ARSQL, ARUserRep;

procedure EditableReport(Rep: TARUserRep);

implementation

uses Main;

procedure Reculc(Rep: TARUserRep);forward;
procedure ReportCanEdit(Rep: TARUserRep; IdxBand:integer; IdxCell:integer; var CanEdit:boolean);forward;
procedure ReportCellChange(Rep: TARUserRep; IdxBand:integer; IdxCell:integer);forward;

procedure EditableReport(Rep: TARUserRep);
var i:integer;
begin
  DemoDlg.CurrentCanEditEventHandler    :=ReportCanEdit;
  DemoDlg.CurrentCellChangeEventHandler :=ReportCellChange;
  Rep.Options:=Rep.Options + [roEditing];

	Rep.Load(ExtractFilePath(ParamStr(0)) + '\Editable.ar');
  Rep.Title:='Editable report';
	Rep.AddBands('Title');

  for i:=0 to 9 do begin
		Rep.M['A']:=Random * 1000.0;
		Rep.F['B']:=Random * 10.0;

		Rep.AddBands('Band');
	end;

  Rep.AddBands('Summary');
  Rep.FixedBands:=1;
  
  Rep.Hint:='Press F2 to edit';

  Reculc(Rep);
end;

procedure Reculc(Rep: TARUserRep);
var IdxBand:integer;
    A, B, SumA, SumC, SumD:extended;
begin
  SumA:=0.0;
  SumC:=0.0;
  SumD:=0.0;

  for IdxBand:=0 to Rep.BandCount['Band'] - 1 do begin
    A:=Rep.Cells['Band', IdxBand, 'A'].M;
    B:=Rep.Cells['Band', IdxBand, 'B'].F / 100.0;

    Rep.Cells['Band', IdxBand, 'C'].M:=A * B;
    Rep.Cells['Band', IdxBand, 'D'].M:=A * (1.0 - B);

    SumA:=SumA + A;
    SumC:=SumC + A * B;
    SumD:=SumD + A * (1.0 - B);
  end;

  Rep.Cells['Summary', 0, 'Sum_A'].M:=SumA;
  Rep.Cells['Summary', 0, 'Sum_C'].M:=SumC;
  Rep.Cells['Summary', 0, 'Sum_D'].M:=SumD;

  Rep.Invalidate;
end;

procedure ReportCanEdit(Rep: TARUserRep; IdxBand:integer; IdxCell:integer; var CanEdit:boolean);
begin
  CanEdit:=(CompareText(Rep.SrcRep.Bands[IdxBand].Name, 'Band') = 0) and (IdxCell < 2);
end;

procedure ReportCellChange(Rep: TARUserRep; IdxBand:integer; IdxCell:integer);
begin
  Reculc(Rep);
end;

end.
