unit ExpandOnDemand;
//************************************************************//
//                         AND Report                        //
//  Eugene Hrulev (mrHru) Laxian Key, Omsk, Russia 1999,2001 //
//  Oleg Melnikov (muler) Laxian Key, Omsk, Russia 1999,2001 //
//************************************************************//

{$INCLUDE DEFINES.INC}

interface

uses
  SysUtils,
  {$IFDEF CLX}
  {$ELSE}
    ARSQL,
  {$ENDIF}

  ARRep, ARUserRep;

procedure ExpandOnDemandReport(Rep: TARUserRep);

implementation

uses Main;

procedure OnSelectBand(Rep:TARUserRep; IdxBand: Integer);forward;

procedure ExpandOnDemandReport(Rep: TARUserRep);
var band:TARBand;
    {$IFDEF CLX}
    {$ELSE}
      Q:TSQL;
    {$ENDIF}
begin
	Rep.Load(ExtractFilePath(ParamStr(0)) + '\SeveralGroup.ar');
  Rep.Title:='Several group report - expand on demain';

	Rep.AddBands('Title');
	Rep.AddBands('Header');

  {$IFDEF CLX}
  {$ELSE}
    Q:=TSQL.CreateDB(DemoDlg.Database1);
    try
      Q.Add('SELECT C.COMPANY, C.CUSTNO, SUM(LISTPRICE) AS TOTALCUSTOMER ');
      Q.Add('FROM   CUSTOMER C, ORDERS O, ITEMS I, PARTS P ');
      Q.Add('WHERE  C.CUSTNO = O.CUSTNO ');
      Q.Add('       AND O.ORDERNO = I.ORDERNO ');
      Q.Add('       AND I.PARTNO = P.PARTNO ');
      Q.Add('GROUP BY C.COMPANY, C.CUSTNO ');
      Q.Open;
      DemoDlg.ProgressBar.Position:=0;
      DemoDlg.ProgressBar.Max:=Q.RecordCount;

      while not Q.EOF do begin
        Rep.BeginPara;
        Rep.S['Company']:=Q.S['COMPANY'];
        band:=Rep.AddBands('Company');
        band.Marked:=true;
        band.ID:=Q.I['CUSTNO'];

        Rep.C['TotalCustomer']:=Q.C['TOTALCUSTOMER'];
        Rep.AddBands('CompanyFooter');

        Q.Next;
        DemoDlg.ProgressBar.StepIt;
      end;

      SelectBand:=OnSelectBand;
    finally
      Q.Free;
    end;
  {$ENDIF}
end;

procedure OnSelectBand(Rep:TARUserRep; IdxBand: Integer);
var band, subband:TARBand;
		OrderNo:integer;
    {$IFDEF CLX}
    {$ELSE}
      Q:TSQL;
    {$ENDIF}
begin
  band:=TARBand(Rep.SrcRep[IdxBand]);

  if band.Expandable then begin
    band.Expanded:= not band.Expanded;
    Rep.Invalidate;
  end else begin
    if band.Marked then begin
      {$IFDEF CLX}
      {$ELSE}
        Q:=TSQL.CreateDB(DemoDlg.Database1);
        try
          if CompareText(band.Name, 'Company') = 0 then begin
            Q.Add('SELECT ORDERNO, SALEDATE, SUM(LISTPRICE) AS TOTALPRICE ');
            Q.Add('FROM   ORDERS O, ITEMS I, PARTS P ');
            Q.Add('WHERE  O.CUSTNO      = :CUSTNO ');
            Q.Add('       AND O.ORDERNO = I.ORDERNO ');
            Q.Add('       AND I.PARTNO  = P.PARTNO ');
            Q.Add('GROUP  BY ORDERNO, SALEDATE ');
            Q.I['CUSTNO']:=band.ID;
            Q.Open;
            while not Q.EOF do begin
              OrderNo:=Q.I['ORDERNO'];
              Rep.I['OrderNo']	:=OrderNo;
              Rep.D['SaleDate']	:=Q.D['SALEDATE'];
              {$IFDEF D3}
                subband:=Rep.AddSubBandsToBand('OrderNo', band, true);
              {$ELSE}
                subband:=Rep.AddBands('OrderNo', band, true);
              {$ENDIF}
              subband.ID:=OrderNo;
              subband.Marked:=true;
              Rep.C['TotalPrice']	:=Q.C['TOTALPRICE'];
              {$IFDEF D3}
                Rep.AddSubBandsToBand('OrderFooter', band, true);
              {$ELSE}
                Rep.AddBands('OrderFooter', band, true);
              {$ENDIF}
              Q.Next;
            end;
          end else
          if CompareText(band.Name, 'OrderNo') = 0 then begin
            {$IFDEF D3}
              Rep.AddSubBandsToBand('PartHeader', band, false);
            {$ELSE}
              Rep.AddBands('PartHeader', band, false);
            {$ENDIF}
            Q.Add('SELECT * ');
            Q.Add('FROM   ITEMS I, PARTS P ');
            Q.Add('WHERE  I.ORDERNO     = :ORDERNO ');
            Q.Add('       AND I.PARTNO  = P.PARTNO ');
            Q.I['ORDERNO']:=band.ID;
            Q.Open;
            while not Q.EOF do begin
              Rep.I['PartNo']			:=Q.I['PARTNO'];
              Rep.S['Description']:=Q.S['DESCRIPTION'];
              Rep.C['ListPrice']	:=Q.C['LISTPRICE'];
              {$IFDEF D3}
                Rep.AddSubBandsToBand('Detail', band, true);
              {$ELSE}
                Rep.AddBands('Detail', band, true);
              {$ENDIF}
              Q.Next;
            end;
          end;
          band.Marked:=false;
        finally
          Q.Free;
        end;
      {$ENDIF}
    end;
  end;
end;

end.

