unit Interactive;
//************************************************//
//                   AND Report                  //
//  Eugene Hrulev (mrHru) Osmk, Russia 1999,2000 //
//  Oleg Melnikov (muler) Osmk, Russia 1999,2000 //
//************************************************//

interface

uses
  SysUtils, Forms, Dialogs,

  ARSQL, ARUserRep;

procedure InteractiveReport(Rep: TARUserRep);


implementation

uses Main;

procedure ReportDblClick(Rep: TARUserRep);forward;

procedure InteractiveReport(Rep: TARUserRep);
var Q:TSQL;
begin
  DemoDlg.CurrentDblClickEventHandler:=ReportDblClick;

	Rep.Load(ExtractFilePath(ParamStr(0)) + '\SeveralGroup.ar');
  Rep.Title:='Several group report';

	Rep.AddBands('Title');
	Rep.AddBands('Header');

	Q:=TSQL.CreateDB(DemoDlg.Database1);
	try
		Q.Add('SELECT 	CUSTNO, COMPANY ');
		Q.Add('FROM 		CUSTOMER');
		Q.Add('ORDER BY COMPANY');
		Q.Open;
		while not Q.EOF do begin
      Rep.U['CustNo'] :=Q.I['CUSTNO'];
			Rep.S['Company']:=Q.S['COMPANY'];
			Rep.AddBands('CompanyHeader');
			Q.Next;
		end;
    Rep.ShowHint:=true;
    Rep.Hint:='Double click to expand';
	finally
		Q.Free;
	end;
end;

procedure ProcessCustNo(Rep: TARUserRep);
var CustNo, BandIdx:integer;
    Q:TSQL;
		TotalCustomer:currency;
begin
  CustNo:=Rep.CurrCell.UserVarValue;

  if CustNo > 0 then begin              // expand
    BandIdx:=Rep.CurrBandIdx;
    Q:=TSQL.CreateDB(DemoDlg.Database1);
    try
      Q.Add('SELECT 	O.ORDERNO, O.SALEDATE, SUM(P.LISTPRICE) AS LISTPRICE ');
      Q.Add('FROM 		ORDERS O, ITEMS I, PARTS P ');
      Q.Add('WHERE 	  O.CUSTNO  = :CUSTNO AND ');
      Q.Add('				  O.ORDERNO = I.ORDERNO AND ');
      Q.Add('				  I.PARTNO  = P.PARTNO ');
      Q.Add('GROUP BY O.ORDERNO, O.SALEDATE ');
      Q.I['CUSTNO']:=CustNo;
      Q.Open;

      TotalCustomer:=0.0;
      while not Q.EOF do begin
        Rep.U['OrderNo']	:=Q.I['ORDERNO'];
        Rep.I['OrderNo']	:=Q.I['ORDERNO'];
        Rep.D['SaleDate']	:=Q.D['SALEDATE'];
        BandIdx:=BandIdx + Rep.InsertBands(BandIdx, 'OrderHeader');

        Rep.C['TotalPrice']	:=Q.C['LISTPRICE'];
        BandIdx:=BandIdx + Rep.InsertBands(BandIdx, 'OrderFooter');

        TotalCustomer:=TotalCustomer + Q.C['LISTPRICE'];
        Q.Next;
      end;

      Rep.C['TotalCustomer']:=TotalCustomer;
      BandIdx:=BandIdx + Rep.InsertBands(BandIdx, 'CompanyFooter');
    finally
      Q.Free;
    end;
  end else begin          //collapse
    while CompareText(Rep.SrcRep.Bands[Rep.CurrBandIdx + 1].Cells[0].UserVar, 'CustNo') <> 0 do begin
      Rep.DeleteBand(Rep.CurrBandIdx + 1);
    end;
  end;

  Rep.CurrCell.UserVarValue:= -CustNo;
end;

procedure ProcessOrderNo(Rep: TARUserRep);
var OrderNo, BandIdx:integer;
    Q:TSQL;
begin
  OrderNo:=Rep.CurrCell.UserVarValue;

  if OrderNo > 0 then begin              // expand
    BandIdx:=Rep.CurrBandIdx;
    Q:=TSQL.CreateDB(DemoDlg.Database1);
    try
			Rep.InsertBands(BandIdx, 'PartHeader');

      Q.Add('SELECT 	P.PARTNO, P.DESCRIPTION, P.LISTPRICE ');
      Q.Add('FROM 		ITEMS I, PARTS P');
      Q.Add('WHERE 	  I.ORDERNO = :ORDERNO AND ');
  		Q.Add('				  P.PARTNO  = I.PARTNO ');
      Q.I['ORDERNO']:=OrderNo;
      Q.Open;

      while not Q.EOF do begin
        Rep.I['PartNo']			:=Q.I['PARTNO'];
        Rep.S['Description']:=Q.S['DESCRIPTION'];
        Rep.C['ListPrice']	:=Q.C['LISTPRICE'];
        BandIdx:=BandIdx + Rep.InsertBands(BandIdx, 'Detail');
        Q.Next;
        DemoDlg.ProgressBar.StepIt;
      end;

    finally
      Q.Free;
    end;
  end else begin          //collapse
    while CompareText(Rep.SrcRep.Bands[Rep.CurrBandIdx + 1].Cells[0].UserVar, 'PartNo') = 0 do begin
      Rep.DeleteBand(Rep.CurrBandIdx + 1);
    end;
  end;

  Rep.CurrCell.UserVarValue:= -OrderNo;
end;

procedure ReportDblClick(Rep: TARUserRep);
begin
  if CompareText(Rep.CurrCell.UserVar, 'CustNo') = 0 then begin
    ProcessCustNo(Rep);
  end else
  if CompareText(Rep.CurrCell.UserVar, 'OrderNo') = 0 then begin
    ProcessOrderNo(Rep);
  end;
end;

end.


