unit MasterDetail;
//************************************************************//
//                         AND Report                        //
//  Eugene Hrulev (mrHru) Laxian Key, Omsk, Russia 1999,2001 //
//  Oleg Melnikov (muler) Laxian Key, Omsk, Russia 1999,2001 //
//************************************************************//

{$INCLUDE DEFINES.INC}

interface

uses
  SysUtils,
  {$IFDEF CLX}
  {$ELSE}
    Forms, Printers, ARSQL, 
  {$ENDIF}
  ARUserRep;

procedure MasterDetailReport(Rep: TARUserRep);

implementation

uses Main;

procedure MasterDetailReport(Rep: TARUserRep);
var Amount:currency;
    {$IFDEF CLX}
    {$ELSE}
      Q1,Q2:TSQL;
    {$ENDIF}
begin
	Rep.Load(ExtractFilePath(ParamStr(0)) + '\MasterDetail.ar');
  Rep.Title:='Master - detail report';

	Rep.AddBands('Title');
	Rep.AddBands('Header');

  {$IFDEF CLX}
  {$ELSE}
   Q1:=TSQL.CreateDB(DemoDlg.Database1);
   Q2:=TSQL.CreateDB(DemoDlg.Database1);
   try
     Q1.Add('SELECT * FROM CUSTOMER ORDER BY COMPANY ');
     Q1.Open;
     DemoDlg.ProgressBar.Position:=0;
     DemoDlg.ProgressBar.Max:=Q1.RecordCount;

     Q2.Add('SELECT * FROM ORDERS WHERE CUSTNO = :CUSTNO ');
     Q2.Prepare;

     while not Q1.EOF do begin
       Rep.BeginPara;

       Rep.S['Company']	:=Q1.S['COMPANY'];
       Rep.S['Contact']	:=Q1.S['CONTACT'];
       Rep.S['Phone']		:=Q1.S['PHONE'];
       Rep.S['Fax']			:=Q1.S['FAX'];
       Rep.I['CustNo']		:=Q1.I['CUSTNO'];
       Rep.AddBands('Company');

       Q2.Close;
       Q2.I['CUSTNO']:=Q1.I['CUSTNO'];
       Q2.Open;
       Amount:=0;
       while not Q2.EOF do begin
         Amount:=Amount + Q2.C['AMOUNTPAID'];

         Rep.I['OrderNo']:=Q2.I['ORDERNO'];
         Rep.D['Date']		:=Q2.D['SALEDATE'];
         Rep.C['Amount']	:=Q2.C['AMOUNTPAID'];
         Rep.AddBands('Amount');
         Q2.Next;
       end;

       Rep.I['TotalOrders']:=Q2.RecordCount;
       Rep.C['TotalAmount']:=Amount;

       Rep.AddBands('Total');
       Q1.Next;
       DemoDlg.ProgressBar.StepIt;

 //      Rep.EndPara;
     end;
   finally
     Q2.Free;
     Q1.Free;
   end;

   Rep.D['CurrDate']:=Now;

   Rep.FixedBands:=2;
  {$ENDIF}
end;

end.
