unit SeveralGroup;
//************************************************************//
//                         AND Report                        //
//  Eugene Hrulev (mrHru) Laxian Key, Omsk, Russia 1999,2001 //
//  Oleg Melnikov (muler) Laxian Key, Omsk, Russia 1999,2001 //
//************************************************************//

{$INCLUDE DEFINES.INC}

interface

uses
  SysUtils,
  {$IFDEF CLX}
  {$ELSE}
    ARSQL, 
  {$ENDIF}

  ARRep, ARUserRep;

procedure SeveralGroupReport(Rep: TARUserRep);

implementation

uses Main;

procedure SeveralGroupReport(Rep: TARUserRep);
var TotalPrice,TotalCustomer:currency;
    band0, band1:TARBand;
    {$IFDEF CLX}
    {$ELSE}
      Q:TSQL;
    {$ENDIF}
begin
	Rep.Load(ExtractFilePath(ParamStr(0)) + '\SeveralGroup.ar');
  Rep.Title:='Several group report';

	Rep.AddBands('Title');
	Rep.AddBands('Header');

  {$IFDEF CLX}
  {$ELSE}
    Q:=TSQL.CreateDB(DemoDlg.Database1);
    try
      Q.Add('SELECT 	 * ');
      Q.Add('FROM 		 CUSTOMER C, ORDERS O, ITEMS I, PARTS P ');
      Q.Add('WHERE 	 C.CUSTNO = O.CUSTNO ');
      Q.Add('				 AND O.ORDERNO = I.ORDERNO ');
      Q.Add('				 AND I.PARTNO = P.PARTNO ');
      Q.Add('ORDER BY C.COMPANY, ORDERNO ');
      Q.Open;
      DemoDlg.ProgressBar.Position:=0;
      DemoDlg.ProgressBar.Max:=Q.RecordCount;

      while not Q.EOF do begin
        if Rep.NewGroup('Company', Q.S['COMPANY']) then begin
          Rep.BeginPara;
          band0:=Rep.AddGroupBands('Company', Q.S['COMPANY']);

          TotalCustomer:=0.0;
          while (not Q.EOF) and (not Rep.NewGroup('Company', Q.S['COMPANY'])) do begin
            TotalPrice:=0.0;
            if Rep.NewGroup('OrderNo', Q.I['ORDERNO']) then begin
              Rep.I['OrderNo']	:=Q.I['ORDERNO'];
              Rep.D['SaleDate']	:=Q.D['SALEDATE'];
              {$IFDEF D3}
                band1:=Rep.AddGroupBandsToBand('OrderNo', Q.I['ORDERNO'], band0, false);
                Rep.AddSubBandsToBand('PartHeader', band1, false);
              {$ELSE}
                band1:=Rep.AddGroupBands('OrderNo', Q.I['ORDERNO'], band0, false);
                Rep.AddBands('PartHeader', band1, false);
              {$ENDIF}

              while (not Q.EOF) and (not Rep.NewGroup('OrderNo', Q.I['ORDERNO'])) do begin
                TotalPrice:=TotalPrice + Q.C['LISTPRICE'];

                Rep.I['PartNo']			:=Q.I['PARTNO'];
                Rep.S['Description']:=Q.S['DESCRIPTION'];
                Rep.C['ListPrice']	:=Q.C['LISTPRICE'];
                {$IFDEF D3}
                  Rep.AddSubBandsToBand('Detail', band1, false);
                {$ELSE}
                  Rep.AddBands('Detail', band1, false);
                {$ENDIF}
                Q.Next;
                DemoDlg.ProgressBar.StepIt;
              end;
              Rep.C['TotalPrice']	:=TotalPrice;
              {$IFDEF D3}
                Rep.AddSubBandsToBand('OrderFooter', band0, false);
              {$ELSE}
                Rep.AddBands('OrderFooter', band0, false);
              {$ENDIF}
            end;
            TotalCustomer:=TotalCustomer + TotalPrice;
          end;
          Rep.C['TotalCustomer']:=TotalCustomer;
          Rep.AddBands('CompanyFooter');
        end;
      end;
    finally
      Q.Free;
    end;
  {$ENDIF}
end;

end.
 